/**
 * Audit Trail information class used with Hibernate Envers
 */
@Entity // comment this line out to disable the Envers who/what tracking stuff
@Table(name = "AuditTrail")
@RevisionEntity(EnversAuditListener.class)
public class EnversAuditTrail
{

    //~ Static fields/initializers -----------------------------------------------------------------

    /** Use serialVersionUID for interoperability. */
    private static final long serialVersionUID = 3742686586388656732L;

    //~ Instance fields ----------------------------------------------------------------------------

    /** DOCUMENT ME! */
    @Id
    @GeneratedValue
    @RevisionNumber
    private long                                     id;

    /** DOCUMENT ME! */
    @RevisionTimestamp
    @Temporal(TemporalType.TIMESTAMP)
    private java.util.Date                    modificationDate;

    /** user that did the modification */
    @Basic(optional = false)
    @Column(
        nullable = false,
        length   = 64
    )
    @NotNull
    @Size(max = 64)
    private String          modifiedBy;

    /** reason for mod */
    @Basic(optional = true)
    @Column(
        nullable = true,
        length   = 255
    )
    @Size(max = 255)
    private String modifyReason;

    /** type of mod */
    @Basic(optional = true)
    @Enumerated(EnumType.STRING)
    @Column(
        nullable = true,
        length   = 64
    )
    private ModelOperationType operationType;
}